~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/testing/selftests/firmware/fw_filesystem.sh

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /tools/testing/selftests/firmware/fw_filesystem.sh (Version linux-6.12-rc7) and /tools/testing/selftests/firmware/fw_filesystem.sh (Version linux-4.17.19)


  1 #!/bin/bash                                         1 #!/bin/bash
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 # This validates that the kernel will load fir      3 # This validates that the kernel will load firmware out of its list of
  4 # firmware locations on disk. Since the user h      4 # firmware locations on disk. Since the user helper does similar work,
  5 # we reset the custom load directory to a loca      5 # we reset the custom load directory to a location the user helper doesn't
  6 # know so we can be sure we're not accidentall      6 # know so we can be sure we're not accidentally testing the user helper.
  7 set -e                                              7 set -e
  8                                                     8 
  9 TEST_REQS_FW_SYSFS_FALLBACK="no"                    9 TEST_REQS_FW_SYSFS_FALLBACK="no"
 10 TEST_REQS_FW_SET_CUSTOM_PATH="yes"                 10 TEST_REQS_FW_SET_CUSTOM_PATH="yes"
 11 TEST_DIR=$(dirname $0)                             11 TEST_DIR=$(dirname $0)
 12 source $TEST_DIR/fw_lib.sh                         12 source $TEST_DIR/fw_lib.sh
 13                                                    13 
 14 RUN_XZ="xz -C crc32 --lzma2=dict=2MiB"         << 
 15 RUN_ZSTD="zstd -q"                             << 
 16                                                << 
 17 check_mods                                         14 check_mods
 18 check_setup                                        15 check_setup
 19 verify_reqs                                        16 verify_reqs
 20 setup_tmp_file                                     17 setup_tmp_file
 21                                                    18 
 22 trap "test_finish" EXIT                            19 trap "test_finish" EXIT
 23                                                    20 
 24 if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; t     21 if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
 25         # Turn down the timeout so failures do     22         # Turn down the timeout so failures don't take so long.
 26         echo 1 >/sys/class/firmware/timeout        23         echo 1 >/sys/class/firmware/timeout
 27 fi                                                 24 fi
 28                                                    25 
 29 if printf '\000' >"$DIR"/trigger_request 2> /d     26 if printf '\000' >"$DIR"/trigger_request 2> /dev/null; then
 30         echo "$0: empty filename should not su     27         echo "$0: empty filename should not succeed" >&2
 31         exit 1                                     28         exit 1
 32 fi                                                 29 fi
 33                                                    30 
 34 if [ ! -e "$DIR"/trigger_async_request ]; then     31 if [ ! -e "$DIR"/trigger_async_request ]; then
 35         echo "$0: empty filename: async trigge     32         echo "$0: empty filename: async trigger not present, ignoring test" >&2
 36         exit $ksft_skip                        << 
 37 else                                               33 else
 38         if printf '\000' >"$DIR"/trigger_async     34         if printf '\000' >"$DIR"/trigger_async_request 2> /dev/null; then
 39                 echo "$0: empty filename shoul     35                 echo "$0: empty filename should not succeed (async)" >&2
 40                 exit 1                             36                 exit 1
 41         fi                                         37         fi
 42 fi                                                 38 fi
 43                                                    39 
 44 # Request a firmware that doesn't exist, it sh     40 # Request a firmware that doesn't exist, it should fail.
 45 if echo -n "nope-$NAME" >"$DIR"/trigger_reques     41 if echo -n "nope-$NAME" >"$DIR"/trigger_request 2> /dev/null; then
 46         echo "$0: firmware shouldn't have load     42         echo "$0: firmware shouldn't have loaded" >&2
 47         exit 1                                     43         exit 1
 48 fi                                                 44 fi
 49 if diff -q "$FW" /dev/test_firmware >/dev/null     45 if diff -q "$FW" /dev/test_firmware >/dev/null ; then
 50         echo "$0: firmware was not expected to     46         echo "$0: firmware was not expected to match" >&2
 51         exit 1                                     47         exit 1
 52 else                                               48 else
 53         if [ "$HAS_FW_LOADER_USER_HELPER" = "y     49         if [ "$HAS_FW_LOADER_USER_HELPER" = "yes" ]; then
 54                 echo "$0: timeout works"           50                 echo "$0: timeout works"
 55         fi                                         51         fi
 56 fi                                                 52 fi
 57                                                    53 
 58 # This should succeed via kernel load or will      54 # This should succeed via kernel load or will fail after 1 second after
 59 # being handed over to the user helper, which      55 # being handed over to the user helper, which won't find the fw either.
 60 if ! echo -n "$NAME" >"$DIR"/trigger_request ;     56 if ! echo -n "$NAME" >"$DIR"/trigger_request ; then
 61         echo "$0: could not trigger request" >     57         echo "$0: could not trigger request" >&2
 62         exit 1                                     58         exit 1
 63 fi                                                 59 fi
 64                                                    60 
 65 # Verify the contents are what we expect.          61 # Verify the contents are what we expect.
 66 if ! diff -q "$FW" /dev/test_firmware >/dev/nu     62 if ! diff -q "$FW" /dev/test_firmware >/dev/null ; then
 67         echo "$0: firmware was not loaded" >&2     63         echo "$0: firmware was not loaded" >&2
 68         exit 1                                     64         exit 1
 69 else                                               65 else
 70         echo "$0: filesystem loading works"        66         echo "$0: filesystem loading works"
 71 fi                                                 67 fi
 72                                                    68 
 73 # Try the asynchronous version too                 69 # Try the asynchronous version too
 74 if [ ! -e "$DIR"/trigger_async_request ]; then     70 if [ ! -e "$DIR"/trigger_async_request ]; then
 75         echo "$0: firmware loading: async trig     71         echo "$0: firmware loading: async trigger not present, ignoring test" >&2
 76         exit $ksft_skip                        << 
 77 else                                               72 else
 78         if ! echo -n "$NAME" >"$DIR"/trigger_a     73         if ! echo -n "$NAME" >"$DIR"/trigger_async_request ; then
 79                 echo "$0: could not trigger as     74                 echo "$0: could not trigger async request" >&2
 80                 exit 1                             75                 exit 1
 81         fi                                         76         fi
 82                                                    77 
 83         # Verify the contents are what we expe     78         # Verify the contents are what we expect.
 84         if ! diff -q "$FW" /dev/test_firmware      79         if ! diff -q "$FW" /dev/test_firmware >/dev/null ; then
 85                 echo "$0: firmware was not loa     80                 echo "$0: firmware was not loaded (async)" >&2
 86                 exit 1                             81                 exit 1
 87         else                                       82         else
 88                 echo "$0: async filesystem loa     83                 echo "$0: async filesystem loading works"
 89         fi                                         84         fi
 90 fi                                                 85 fi
 91                                                    86 
 92 # Try platform (EFI embedded fw) loading too   << 
 93 if [ ! -e "$DIR"/trigger_request_platform ]; t << 
 94         echo "$0: firmware loading: platform t << 
 95 else                                           << 
 96         if printf '\000' >"$DIR"/trigger_reque << 
 97                 echo "$0: empty filename shoul << 
 98                 exit 1                         << 
 99         fi                                     << 
100                                                << 
101         # Note we echo a non-existing name, si << 
102         # are preferred over firmware embedded << 
103         # The test adds a fake entry with the  << 
104         # fw list, so the name does not matter << 
105         if ! echo -n "nope-$NAME" >"$DIR"/trig << 
106                 echo "$0: could not trigger re << 
107                 exit 1                         << 
108         fi                                     << 
109                                                << 
110         # The test verifies itself that the lo << 
111         # the contents for the fake platform f << 
112         echo "$0: platform loading works"      << 
113 fi                                             << 
114                                                << 
115 ### Batched requests tests                         87 ### Batched requests tests
116 test_config_present()                              88 test_config_present()
117 {                                                  89 {
118         if [ ! -f $DIR/reset ]; then               90         if [ ! -f $DIR/reset ]; then
119                 echo "Configuration triggers n     91                 echo "Configuration triggers not present, ignoring test"
120                 exit $ksft_skip                !!  92                 exit 0
121         fi                                         93         fi
122 }                                                  94 }
123                                                    95 
124 # Defaults :                                       96 # Defaults :
125 #                                                  97 #
126 # send_uevent: 1                                   98 # send_uevent: 1
127 # sync_direct: 0                                   99 # sync_direct: 0
128 # name: test-firmware.bin                         100 # name: test-firmware.bin
129 # num_requests: 4                                 101 # num_requests: 4
130 config_reset()                                    102 config_reset()
131 {                                                 103 {
132         echo 1 >  $DIR/reset                      104         echo 1 >  $DIR/reset
133 }                                                 105 }
134                                                   106 
135 release_all_firmware()                            107 release_all_firmware()
136 {                                                 108 {
137         echo 1 >  $DIR/release_all_firmware       109         echo 1 >  $DIR/release_all_firmware
138 }                                                 110 }
139                                                   111 
140 config_set_name()                                 112 config_set_name()
141 {                                                 113 {
142         echo -n $1 >  $DIR/config_name            114         echo -n $1 >  $DIR/config_name
143 }                                                 115 }
144                                                   116 
145 config_set_into_buf()                          << 
146 {                                              << 
147         echo 1 >  $DIR/config_into_buf         << 
148 }                                              << 
149                                                << 
150 config_unset_into_buf()                        << 
151 {                                              << 
152         echo 0 >  $DIR/config_into_buf         << 
153 }                                              << 
154                                                << 
155 config_set_buf_size()                          << 
156 {                                              << 
157         echo $1 >  $DIR/config_buf_size        << 
158 }                                              << 
159                                                << 
160 config_set_file_offset()                       << 
161 {                                              << 
162         echo $1 >  $DIR/config_file_offset     << 
163 }                                              << 
164                                                << 
165 config_set_partial()                           << 
166 {                                              << 
167         echo 1 >  $DIR/config_partial          << 
168 }                                              << 
169                                                << 
170 config_unset_partial()                         << 
171 {                                              << 
172         echo 0 >  $DIR/config_partial          << 
173 }                                              << 
174                                                << 
175 config_set_sync_direct()                          117 config_set_sync_direct()
176 {                                                 118 {
177         echo 1 >  $DIR/config_sync_direct         119         echo 1 >  $DIR/config_sync_direct
178 }                                                 120 }
179                                                   121 
180 config_unset_sync_direct()                        122 config_unset_sync_direct()
181 {                                                 123 {
182         echo 0 >  $DIR/config_sync_direct         124         echo 0 >  $DIR/config_sync_direct
183 }                                                 125 }
184                                                   126 
185 config_set_uevent()                               127 config_set_uevent()
186 {                                                 128 {
187         echo 1 >  $DIR/config_send_uevent         129         echo 1 >  $DIR/config_send_uevent
188 }                                                 130 }
189                                                   131 
190 config_unset_uevent()                             132 config_unset_uevent()
191 {                                                 133 {
192         echo 0 >  $DIR/config_send_uevent         134         echo 0 >  $DIR/config_send_uevent
193 }                                                 135 }
194                                                   136 
195 config_trigger_sync()                             137 config_trigger_sync()
196 {                                                 138 {
197         echo -n 1 > $DIR/trigger_batched_reque    139         echo -n 1 > $DIR/trigger_batched_requests 2>/dev/null
198 }                                                 140 }
199                                                   141 
200 config_trigger_async()                            142 config_trigger_async()
201 {                                                 143 {
202         echo -n 1 > $DIR/trigger_batched_reque    144         echo -n 1 > $DIR/trigger_batched_requests_async 2> /dev/null
203 }                                                 145 }
204                                                   146 
205 config_set_read_fw_idx()                          147 config_set_read_fw_idx()
206 {                                                 148 {
207         echo -n $1 > $DIR/config_read_fw_idx 2    149         echo -n $1 > $DIR/config_read_fw_idx 2> /dev/null
208 }                                                 150 }
209                                                   151 
210 read_firmwares()                                  152 read_firmwares()
211 {                                                 153 {
212         if [ "$(cat $DIR/config_into_buf)" ==  << 
213                 fwfile="$FW_INTO_BUF"          << 
214         else                                   << 
215                 fwfile="$FW"                   << 
216         fi                                     << 
217         if [ "$1" = "componly" ]; then         << 
218                 fwfile="${fwfile}-orig"        << 
219         fi                                     << 
220         for i in $(seq 0 3); do                   154         for i in $(seq 0 3); do
221                 config_set_read_fw_idx $i         155                 config_set_read_fw_idx $i
222                 # Verify the contents are what    156                 # Verify the contents are what we expect.
223                 # -Z required for now -- check    157                 # -Z required for now -- check for yourself, md5sum
224                 # on $FW and DIR/read_firmware    158                 # on $FW and DIR/read_firmware will yield the same. Even
225                 # cmp agrees, so something is     159                 # cmp agrees, so something is off.
226                 if ! diff -q -Z "$fwfile" $DIR !! 160                 if ! diff -q -Z "$FW" $DIR/read_firmware 2>/dev/null ; then
227                         echo "request #$i: fir    161                         echo "request #$i: firmware was not loaded" >&2
228                         exit 1                    162                         exit 1
229                 fi                                163                 fi
230         done                                      164         done
231 }                                                 165 }
232                                                   166 
233 read_partial_firmwares()                       << 
234 {                                              << 
235         if [ "$(cat $DIR/config_into_buf)" ==  << 
236                 fwfile="${FW_INTO_BUF}"        << 
237         else                                   << 
238                 fwfile="${FW}"                 << 
239         fi                                     << 
240                                                << 
241         if [ "$1" = "componly" ]; then         << 
242                 fwfile="${fwfile}-orig"        << 
243         fi                                     << 
244                                                << 
245         # Strip fwfile down to match partial o << 
246         partial_data="$(cat $fwfile)"          << 
247         partial_data="${partial_data:$2:$3}"   << 
248                                                << 
249         for i in $(seq 0 3); do                << 
250                 config_set_read_fw_idx $i      << 
251                                                << 
252                 read_firmware="$(cat $DIR/read << 
253                                                << 
254                 # Verify the contents are what << 
255                 if [ $read_firmware != $partia << 
256                         echo "request #$i: par << 
257                         exit 1                 << 
258                 fi                             << 
259         done                                   << 
260 }                                              << 
261                                                << 
262 read_firmwares_expect_nofile()                    167 read_firmwares_expect_nofile()
263 {                                                 168 {
264         for i in $(seq 0 3); do                   169         for i in $(seq 0 3); do
265                 config_set_read_fw_idx $i         170                 config_set_read_fw_idx $i
266                 # Ensures contents differ         171                 # Ensures contents differ
267                 if diff -q -Z "$FW" $DIR/read_    172                 if diff -q -Z "$FW" $DIR/read_firmware 2>/dev/null ; then
268                         echo "request $i: file    173                         echo "request $i: file was not expected to match" >&2
269                         exit 1                    174                         exit 1
270                 fi                                175                 fi
271         done                                      176         done
272 }                                                 177 }
273                                                   178 
274 test_batched_request_firmware_nofile()            179 test_batched_request_firmware_nofile()
275 {                                                 180 {
276         echo -n "Batched request_firmware() no    181         echo -n "Batched request_firmware() nofile try #$1: "
277         config_reset                              182         config_reset
278         config_set_name nope-test-firmware.bin    183         config_set_name nope-test-firmware.bin
279         config_trigger_sync                       184         config_trigger_sync
280         read_firmwares_expect_nofile              185         read_firmwares_expect_nofile
281         release_all_firmware                      186         release_all_firmware
282         echo "OK"                                 187         echo "OK"
283 }                                                 188 }
284                                                   189 
285 test_batched_request_firmware_into_buf_nofile( << 
286 {                                              << 
287         echo -n "Batched request_firmware_into << 
288         config_reset                           << 
289         config_set_name nope-test-firmware.bin << 
290         config_set_into_buf                    << 
291         config_trigger_sync                    << 
292         read_firmwares_expect_nofile           << 
293         release_all_firmware                   << 
294         echo "OK"                              << 
295 }                                              << 
296                                                << 
297 test_request_partial_firmware_into_buf_nofile( << 
298 {                                              << 
299         echo -n "Test request_partial_firmware << 
300         config_reset                           << 
301         config_set_name nope-test-firmware.bin << 
302         config_set_into_buf                    << 
303         config_set_partial                     << 
304         config_set_buf_size $2                 << 
305         config_set_file_offset $1              << 
306         config_trigger_sync                    << 
307         read_firmwares_expect_nofile           << 
308         release_all_firmware                   << 
309         echo "OK"                              << 
310 }                                              << 
311                                                << 
312 test_batched_request_firmware_direct_nofile()     190 test_batched_request_firmware_direct_nofile()
313 {                                                 191 {
314         echo -n "Batched request_firmware_dire    192         echo -n "Batched request_firmware_direct() nofile try #$1: "
315         config_reset                              193         config_reset
316         config_set_name nope-test-firmware.bin    194         config_set_name nope-test-firmware.bin
317         config_set_sync_direct                    195         config_set_sync_direct
318         config_trigger_sync                       196         config_trigger_sync
319         release_all_firmware                      197         release_all_firmware
320         echo "OK"                                 198         echo "OK"
321 }                                                 199 }
322                                                   200 
323 test_request_firmware_nowait_uevent_nofile()      201 test_request_firmware_nowait_uevent_nofile()
324 {                                                 202 {
325         echo -n "Batched request_firmware_nowa    203         echo -n "Batched request_firmware_nowait(uevent=true) nofile try #$1: "
326         config_reset                              204         config_reset
327         config_set_name nope-test-firmware.bin    205         config_set_name nope-test-firmware.bin
328         config_trigger_async                      206         config_trigger_async
329         release_all_firmware                      207         release_all_firmware
330         echo "OK"                                 208         echo "OK"
331 }                                                 209 }
332                                                   210 
333 test_wait_and_cancel_custom_load()                211 test_wait_and_cancel_custom_load()
334 {                                                 212 {
335         if [ "$HAS_FW_LOADER_USER_HELPER" != "    213         if [ "$HAS_FW_LOADER_USER_HELPER" != "yes" ]; then
336                 return                            214                 return
337         fi                                        215         fi
338         local timeout=10                          216         local timeout=10
339         name=$1                                   217         name=$1
340         while [ ! -e "$DIR"/"$name"/loading ];    218         while [ ! -e "$DIR"/"$name"/loading ]; do
341                 sleep 0.1                         219                 sleep 0.1
342                 timeout=$(( $timeout - 1 ))       220                 timeout=$(( $timeout - 1 ))
343                 if [ "$timeout" -eq 0 ]; then     221                 if [ "$timeout" -eq 0 ]; then
344                         echo "firmware interfa    222                         echo "firmware interface never appeared:" >&2
345                         echo "$DIR/$name/loadi    223                         echo "$DIR/$name/loading" >&2
346                         exit 1                    224                         exit 1
347                 fi                                225                 fi
348         done                                      226         done
349         echo -1 >"$DIR"/"$name"/loading           227         echo -1 >"$DIR"/"$name"/loading
350 }                                                 228 }
351                                                   229 
352 test_request_firmware_nowait_custom_nofile()      230 test_request_firmware_nowait_custom_nofile()
353 {                                                 231 {
354         echo -n "Batched request_firmware_nowa    232         echo -n "Batched request_firmware_nowait(uevent=false) nofile try #$1: "
355         config_reset                              233         config_reset
356         config_unset_uevent                       234         config_unset_uevent
357         RANDOM_FILE_PATH=$(setup_random_file_f    235         RANDOM_FILE_PATH=$(setup_random_file_fake)
358         RANDOM_FILE="$(basename $RANDOM_FILE_P    236         RANDOM_FILE="$(basename $RANDOM_FILE_PATH)"
359         config_set_name $RANDOM_FILE              237         config_set_name $RANDOM_FILE
360         config_trigger_async &                    238         config_trigger_async &
361         test_wait_and_cancel_custom_load $RAND    239         test_wait_and_cancel_custom_load $RANDOM_FILE
362         wait                                      240         wait
363         release_all_firmware                      241         release_all_firmware
364         echo "OK"                                 242         echo "OK"
365 }                                                 243 }
366                                                   244 
367 test_batched_request_firmware()                   245 test_batched_request_firmware()
368 {                                                 246 {
369         echo -n "Batched request_firmware() $2 !! 247         echo -n "Batched request_firmware() try #$1: "
370         config_reset                              248         config_reset
371         config_trigger_sync                       249         config_trigger_sync
372         read_firmwares $2                      !! 250         read_firmwares
373         release_all_firmware                   << 
374         echo "OK"                              << 
375 }                                              << 
376                                                << 
377 test_batched_request_firmware_into_buf()       << 
378 {                                              << 
379         echo -n "Batched request_firmware_into << 
380         config_reset                           << 
381         config_set_name $TEST_FIRMWARE_INTO_BU << 
382         config_set_into_buf                    << 
383         config_trigger_sync                    << 
384         read_firmwares $2                      << 
385         release_all_firmware                      251         release_all_firmware
386         echo "OK"                                 252         echo "OK"
387 }                                                 253 }
388                                                   254 
389 test_batched_request_firmware_direct()            255 test_batched_request_firmware_direct()
390 {                                                 256 {
391         echo -n "Batched request_firmware_dire !! 257         echo -n "Batched request_firmware_direct() try #$1: "
392         config_reset                              258         config_reset
393         config_set_sync_direct                    259         config_set_sync_direct
394         config_trigger_sync                       260         config_trigger_sync
395         release_all_firmware                      261         release_all_firmware
396         echo "OK"                                 262         echo "OK"
397 }                                                 263 }
398                                                   264 
399 test_request_firmware_nowait_uevent()             265 test_request_firmware_nowait_uevent()
400 {                                                 266 {
401         echo -n "Batched request_firmware_nowa !! 267         echo -n "Batched request_firmware_nowait(uevent=true) try #$1: "
402         config_reset                              268         config_reset
403         config_trigger_async                      269         config_trigger_async
404         release_all_firmware                      270         release_all_firmware
405         echo "OK"                                 271         echo "OK"
406 }                                                 272 }
407                                                   273 
408 test_request_firmware_nowait_custom()             274 test_request_firmware_nowait_custom()
409 {                                                 275 {
410         echo -n "Batched request_firmware_nowa !! 276         echo -n "Batched request_firmware_nowait(uevent=false) try #$1: "
411         config_reset                              277         config_reset
412         config_unset_uevent                       278         config_unset_uevent
413         RANDOM_FILE_PATH=$(setup_random_file)     279         RANDOM_FILE_PATH=$(setup_random_file)
414         RANDOM_FILE="$(basename $RANDOM_FILE_P    280         RANDOM_FILE="$(basename $RANDOM_FILE_PATH)"
415         if [ -n "$2" -a "$2" != "normal" ]; th << 
416                 compress_"$2"_"$COMPRESS_FORMA << 
417         fi                                     << 
418         config_set_name $RANDOM_FILE              281         config_set_name $RANDOM_FILE
419         config_trigger_async                      282         config_trigger_async
420         release_all_firmware                      283         release_all_firmware
421         echo "OK"                                 284         echo "OK"
422 }                                                 285 }
423                                                   286 
424 test_request_partial_firmware_into_buf()       << 
425 {                                              << 
426         echo -n "Test request_partial_firmware << 
427         config_reset                           << 
428         config_set_name $TEST_FIRMWARE_INTO_BU << 
429         config_set_into_buf                    << 
430         config_set_partial                     << 
431         config_set_buf_size $2                 << 
432         config_set_file_offset $1              << 
433         config_trigger_sync                    << 
434         read_partial_firmwares normal $1 $2    << 
435         release_all_firmware                   << 
436         echo "OK"                              << 
437 }                                              << 
438                                                << 
439 do_tests ()                                    << 
440 {                                              << 
441         mode="$1"                              << 
442         suffix="$2"                            << 
443                                                << 
444         for i in $(seq 1 5); do                << 
445                 test_batched_request_firmware$ << 
446         done                                   << 
447                                                << 
448         for i in $(seq 1 5); do                << 
449                 test_batched_request_firmware_ << 
450         done                                   << 
451                                                << 
452         for i in $(seq 1 5); do                << 
453                 test_batched_request_firmware_ << 
454         done                                   << 
455                                                << 
456         for i in $(seq 1 5); do                << 
457                 test_request_firmware_nowait_u << 
458         done                                   << 
459                                                << 
460         for i in $(seq 1 5); do                << 
461                 test_request_firmware_nowait_c << 
462         done                                   << 
463 }                                              << 
464                                                << 
465 # Only continue if batched request triggers ar    287 # Only continue if batched request triggers are present on the
466 # test-firmware driver                            288 # test-firmware driver
467 test_config_present                               289 test_config_present
468                                                   290 
469 # test with the file present                      291 # test with the file present
470 echo                                              292 echo
471 echo "Testing with the file present..."           293 echo "Testing with the file present..."
472 do_tests normal                                !! 294 for i in $(seq 1 5); do
473                                                !! 295         test_batched_request_firmware $i
474 # Partial loads cannot use fallback, so do not !! 296 done
475 test_request_partial_firmware_into_buf 0 10    !! 297 
476 test_request_partial_firmware_into_buf 0 5     !! 298 for i in $(seq 1 5); do
477 test_request_partial_firmware_into_buf 1 6     !! 299         test_batched_request_firmware_direct $i
478 test_request_partial_firmware_into_buf 2 10    !! 300 done
                                                   >> 301 
                                                   >> 302 for i in $(seq 1 5); do
                                                   >> 303         test_request_firmware_nowait_uevent $i
                                                   >> 304 done
                                                   >> 305 
                                                   >> 306 for i in $(seq 1 5); do
                                                   >> 307         test_request_firmware_nowait_custom $i
                                                   >> 308 done
479                                                   309 
480 # Test for file not found, errors are expected    310 # Test for file not found, errors are expected, the failure would be
481 # a hung task, which would require a hard rese    311 # a hung task, which would require a hard reset.
482 echo                                              312 echo
483 echo "Testing with the file missing..."           313 echo "Testing with the file missing..."
484 do_tests nofile _nofile                        !! 314 for i in $(seq 1 5); do
485                                                !! 315         test_batched_request_firmware_nofile $i
486 # Partial loads cannot use fallback, so do not !! 316 done
487 test_request_partial_firmware_into_buf_nofile  !! 317 
488 test_request_partial_firmware_into_buf_nofile  !! 318 for i in $(seq 1 5); do
489 test_request_partial_firmware_into_buf_nofile  !! 319         test_batched_request_firmware_direct_nofile $i
490 test_request_partial_firmware_into_buf_nofile  !! 320 done
491                                                !! 321 
492 test_request_firmware_compressed ()            !! 322 for i in $(seq 1 5); do
493 {                                              !! 323         test_request_firmware_nowait_uevent_nofile $i
494         export COMPRESS_FORMAT="$1"            !! 324 done
495                                                !! 325 
496         # test with both files present         !! 326 for i in $(seq 1 5); do
497         compress_both_"$COMPRESS_FORMAT" $FW   !! 327         test_request_firmware_nowait_custom_nofile $i
498         compress_both_"$COMPRESS_FORMAT" $FW_I !! 328 done
499                                                << 
500         config_set_name $NAME                  << 
501         echo                                   << 
502         echo "Testing with both plain and $COM << 
503         do_tests both                          << 
504                                                << 
505         # test with only compressed file prese << 
506         mv "$FW" "${FW}-orig"                  << 
507         mv "$FW_INTO_BUF" "${FW_INTO_BUF}-orig << 
508                                                << 
509         config_set_name $NAME                  << 
510         echo                                   << 
511         echo "Testing with only $COMPRESS_FORM << 
512         do_tests componly                      << 
513                                                << 
514         mv "${FW}-orig" "$FW"                  << 
515         mv "${FW_INTO_BUF}-orig" "$FW_INTO_BUF << 
516 }                                              << 
517                                                << 
518 compress_both_XZ ()                            << 
519 {                                              << 
520         $RUN_XZ -k "$@"                        << 
521 }                                              << 
522                                                << 
523 compress_componly_XZ ()                        << 
524 {                                              << 
525         $RUN_XZ "$@"                           << 
526 }                                              << 
527                                                << 
528 compress_both_ZSTD ()                          << 
529 {                                              << 
530         $RUN_ZSTD -k "$@"                      << 
531 }                                              << 
532                                                << 
533 compress_componly_ZSTD ()                      << 
534 {                                              << 
535         $RUN_ZSTD --rm "$@"                    << 
536 }                                              << 
537                                                << 
538 if test "$HAS_FW_LOADER_COMPRESS_XZ" = "yes";  << 
539         test_request_firmware_compressed XZ    << 
540 fi                                             << 
541                                                << 
542 if test "$HAS_FW_LOADER_COMPRESS_ZSTD" = "yes" << 
543         test_request_firmware_compressed ZSTD  << 
544 fi                                             << 
545                                                   329 
546 exit 0                                            330 exit 0
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php